##############################################################
#
#this is basicaly  module for any other Scotty agent
#it can be added to egsisting agent 
#agent initialisation file
#
#Tue May  8 12:53:39 MET DST 2001
#Damir Delija, ddelija@srce.hr
#
##############################################################



##########*#####*###*##*#*#**#***#****#***=**==*===---===--=--------
##       Name: Df_get
##    Purpose: get values from iostat -ne
## Parameters: Agent session handle
##    Globals: Df IFileSystemNumber FileSystemLastChange
## Ext. Comms: iostat -ne, must be in path
##     Return: n/a
##########*#####*###*##*#*#**#***#****#***=**==*===---===--=--------

proc Df_get { s  } {


	set ind 0
	global Df FileSystemNumber FileSystemLastChange

	set f [open "|df -lk"] ;#this is for solaris
	#mark no lines in table
	$s instance  FileSystemNumber.0  FileSystemNumber

	#mark new time stamp
	$s instance   FileSystemLastChange.0   FileSystemLastChange  [clock seconds]
	
	#parse output 
	gets $f line;  #remove the first two lines

	while { [gets $f line ] >= 0 } {

		incr ind
		set  FileSystemNumber $ind ;#mark no lines in table

		scan $line "%s %d %d %d %d%% %s" FileSystemDevice KbTotal KbUsed KbAvail KbCapacityPer MountedOn

		set AR(${FileSystemDevice}) $ind ;# just for df -oi, temp index by filesyetm device 

		$s instance FileSystemDevice.${ind} Df(FileSystemDevice,${ind}) $FileSystemDevice
		$s instance KbTotal.${ind} Df(KbTotal,${ind}) $KbTotal
		$s instance MountedOn.${ind} Df(MountedOn,${ind}) $MountedOn

		$s instance KbUsed.${ind} Df(KbUsed,${ind}) $KbUsed
		$s instance KbAvail.${ind} Df(KbAvail,${ind}) $KbAvail
		$s instance KbCapacityPer.${ind} Df(KbCapacityPer,${ind}) $KbCapacityPer
		$s instance KbCapacityPer.${ind} Df(KbCapacityPer,${ind}) $KbCapacityPer

	}

	close $f

# df -io operations, error s possible because od stderr output ...

	set f [open "|df -oi"]

	gets $f line;  #remove the first two lines

	while { [gets $f line ] >= 0 } {
		scan $line "%s %d %d %d%% %s" FileSystemDevice Iused Ifree IusedPer MountedOn

		set ind $AR(${FileSystemDevice})

		$s instance Iused.${ind} Df(Iused,${ind}) $Iused
		$s instance Ifree.${ind} Df(Ifree,${ind}) $Ifree
		$s instance IusedPer.${ind} Df(IusedPer,${ind}) $IusedPer

	}
	catch {			;#to get rid of error messages
		close $f
	}

}

##########*#####*###*##*#*#**#***#****#***=**==*===---===--=--------
##       Name: Df_Init
##    Purpose: Initalise filesyetem. monitoring subsystem 
## Parameters: Agent session handle, or {}
##    Globals: PORT for agent session
##     Return: n/a
##########*#####*###*##*#*#**#***#****#***=**==*===---===--=--------
proc Df_Init { s } {

	mib load carnet.mib

	mib load df.mib

	#initialise the env. subsystem
	Df_get $s 

	#bind data gathering A
	#data is fetched from outside only when 
	#FileSYstemNumber.0 is reguested, see in mib ...

	$s bind FileSystemNumber.0 get { 
		Df_get  %S

	#add logging action for control
	}

}

##########*#####*###*##*#*#**#***#****#***=**==*===---===--=--------
