##############################################################
#
#this is basicaly  module for any other Scotty agent
#it can be added to egsisting agent 
#agent initialisation file
#
#Tue May  8 12:53:39 MET DST 2001
#Damir Delija, ddelija@srce.hr
#
##############################################################

set DT 10

##########*#####*###*##*#*#**#***#****#***=**==*===---===--=--------
##       Name: Time_Control
##    Purpose: Acess control based on time, IP and frequency
## Parameters: A Agent session handle, r session sequence number
##    Globals: asociative arrays with acess data
## Ext. Comms: 
##     Return: n/a or error, if condition violation
##########*#####*###*##*#*#**#***#****#***=**==*===---===--=--------

proc Time_Control { A r } {

global LAST	;# array with time-IP binding it can grow
global R	;# arry with session sequence-IP binding
global DT	;# minimal time period between sessions

	#current acess time
	set cT [getclock]

	#no data in array, first acess OR
	#timeperiod is bigger than pause OR
	#it is one walk, get-bulk ...

	if { 	[catch { set  lT $LAST($A) } ]  ||
		[expr $cT - $lT] > $DT ||
		[expr  $r - $R($A) ] == 1 } {
	
			set LAST($A) $cT
			set R($A) $r
			return 1
	}
	error "to often"
}


##########*#####*###*##*#*#**#***#****#***=**==*===---===--=--------
##       Name: System_Init
##    Purpose: Initalise system group
## Parameters: Agent session handle
##    Globals: system group names
## Ext. Comms: uname, has to be in PATH!
##     Return: n/a
##########*#####*###*##*#*#**#***#****#***=**==*===---===--=--------

proc Access_Init { s } {

	load ./tcpd.so	   ;#tcpd wpapper interface in Beta

	foreach i { get set create check commit rollback } {

		$s bind internet $i  {
			if { [hosts_ctl snmp {} %A {} ] } {
				Time_Control %A %R
				return 1
			}
			syslog info "SNMP-ilegal:%A %T %V"
			error ""
		} 

	}

}

