/* ---------------------------------------------------------------
Thu May 18 15:40:53 MET DST 2000

get the fan status, if there are failures or no

--------------------------------------------------------------- */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <kstat.h>
#include <sys/envctrl_gen.h>

#include "envstat.h"
extern int output;
extern char outbuff[];


/* -----------------------------------------------------------
print the actual data

structure is documented in sys/envctrl_gen.h file

type -> number of fan
fans_ok -> 1 fans are OK, 0 failure
fanflt_num -> number of faulty fan if fans_ok == 0, else 0

----------------------------------------------------------- */

void *print_envctrl_fan ( envctrl_fan_t *p, int i ) {

	if (!p) return(NULL);
	if (output==SIMPLE_OUT) {	
		sprintf (outbuff,"\t%d\t%d\t%d",  
			(int)p->type,
			(int)p->fans_ok,
			(int)p->fanflt_num
		);
	} else {
		sprintf (outbuff," %d,type %d %d,fans_ok %d %d,fanflt_num %d \\",  
			i, (int)p->type,
			i, (int)p->fans_ok,
			i, (int)p->fanflt_num
		);
	}
	myOut(outbuff);
	return (void*)(p+1);
}

/*
just header output
*/
void print_fan_header (void) {
	if (output==SIMPLE_OUT) {	
		sprintf (outbuff,"#TABLE:\tfan\n#ROWS:\ttype\tfans_ok\tfanflt_num");
	} else {
		sprintf (outbuff,"array set fan { \\");
	}
	myOut(outbuff);
}


/*
get the data and walk trough records 
*/

void print_fan(kstat_ctl_t *kc)
{
kstat_t *ksp;
envctrl_fan_t *tps;
int i;


/* 
find the fansat in envctrl in kstat
*/

	ksp = kstat_lookup(kc,
		ENVCTRL_MODULE_NAME,
		-1,
		ENVCTRL_KSTAT_FANSTAT
	);

	print_fan_header();

	if(ksp  && kstat_read(kc,ksp,NULL)!=-1){
		/* wakl trough modules */
		tps=ksp->ks_data;
		for (i=0; tps && i<(int)ksp->ks_ndata; i++) {
			tps=print_envctrl_fan ( tps,i  );
		}
	}
	print_fan_trailer();
}

	

/* end */
