/* ---------------------------------------------------------------
Thu May 18 15:45:07 MET DST 2000

get the temperature data from kstat
main reason for doing all this 

--------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <kstat.h>
#include <sys/envctrl_gen.h>

#include "envstat.h"
extern int output;
extern char outbuff[];

/*
print the header
*/
void print_temp_header (void ) {

	if (output==SIMPLE_OUT) {
		sprintf (outbuff,"#TABLE:\ttemperature\n#ROWS:\tlabel\tvalue");
	} else {
		sprintf (outbuff,"temperature { \\");
	}
	myOut(outbuff);
}

/*
print the temperature data
data is documented in sys/envctrl_gen.h file

label is name of the sensor (measurring point)
value is actual value in Celsius

*/
void *print_envctrl_temp ( envctrl_temp_t *p, int i ) {

	if (!p) return (NULL);

	if (output==SIMPLE_OUT) {
		sprintf (outbuff,"\t%s\t%d", p->label, (int)p->value);
	} else {
		sprintf (outbuff," %d,label %s %d,value %d \\", 
			i,p->label, i,(int)p->value);
	}

	myOut(outbuff);
	return (void*)(p+1);
}



void print_temp(kstat_ctl_t *kc)
{
kstat_t *ksp;
envctrl_temp_t *tps;
int i;

/* 
find the ENVCTRL_KSTAT_TEMPERATURE in kstat ENVCTRL_MODULE_NAME,
*/
	print_temp_header();

	ksp = kstat_lookup(kc,
		ENVCTRL_MODULE_NAME,
		-1,
		ENVCTRL_KSTAT_TEMPERATURE
	);

	if(ksp && kstat_read(kc,ksp,NULL)!=-1){
	
		tps=ksp->ks_data;

		/* walk trough modules */
		for (i=0; i<(int)ksp->ks_ndata; i++) {
			tps=print_envctrl_temp ( tps,i ) ;
		}
	} 
	print_temp_trailer();
}

	

/* end */
